package testkinectv2;

import utildll.*;

public class Wrp_IAudioSource {
	private static final int CHARSET = Arg.UNICODE;
	private long source = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribeFrameCaptured = 3,
			IDX_UnsubscribeFrameCaptured = 4,
			IDX_GetFrameCapturedEventData = 5,
			IDX_get_KinectSensor = 6,
			IDX_get_IsActive = 7,
			IDX_get_SubFrameLengthInBytes = 8,
			IDX_get_SubFrameDuration = 9,
			IDX_get_MaxSubFrameCount = 10,
			IDX_OpenReader = 11,
			IDX_get_AudioBeams = 12,
			IDX_get_AudioCalibrationState = 13;
	
	public Wrp_IAudioSource(long source) {
		this.source = source;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(source, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
		HRESULT OpenReader(
		         IAudioBeamFrameReader **reader
		)
	 */
	private class Arg_OpenReader extends Arg_property {
		private long[] reader;
		
		private Arg_OpenReader(long[] reader) {
			this.reader = reader;
		}
	}

	public int OpenReader(long[] reader) throws Exception_KINECT {
		Arg_OpenReader arg = new Arg_OpenReader(reader);

		int intRtn = JInvoker.callIntMethod(source, IDX_OpenReader, arg);
		
		System.out.println("OpenReader rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("OpenReader");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("OpenReader");

		return intRtn;
	}

}
