package testkinectv2;

import utildll.*;

public class Wrp_IBody {
	private static final int CHARSET = Arg.UNICODE;
	private long body = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_GetJoints = 3,
			IDX_GetJointOrientations = 4,
			IDX_get_Engaged = 5,
			IDX_GetExpressionDetectionResults = 6,
			IDX_GetActivityDetectionResults = 7,
			IDX_GetAppearanceDetectionResults = 8,
			IDX_get_HandLeftState = 9,
			IDX_get_HandLeftConfidence = 10,
			IDX_get_HandRightState = 11,
			IDX_get_HandRightConfidence = 12,
			IDX_get_ClippedEdges = 13,
			IDX_get_TrackingId = 14,
			IDX_get_IsTracked = 15,
			IDX_get_IsRestricted = 16,
			IDX_get_Lean = 17,
			IDX_get_LeanTrackingState = 18;
	
	public Wrp_IBody(long body) {
		this.body = body;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(body, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT GetJoints(
	         _Pre_equal_to_(JointType_Count)UINT capacity,
	         Joint *joints
	)
	 */
	private class Arg_GetJoints extends Arg_property {
		private int capacity;
		private Struct_Joint[] joints;
		
		private Arg_GetJoints(int capacity, Struct_Joint[] joints) {
			this.capacity = capacity;
			this.joints = joints;
		}
	}

	public int GetJoints(int capacity, Struct_Joint[] joints) throws Exception_KINECT {
		Arg_GetJoints arg = new Arg_GetJoints(capacity, joints);

		int intRtn = JInvoker.callIntMethod(body, IDX_GetJoints, arg);
		
		System.out.println("GetJoints rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetJoints");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetJoints");

		return intRtn;
	}

	/*
	HRESULT GetJointOrientations(
	         _Pre_equal_to_(JointType_Count)UINT capacity,
	         JointOrientation *jointOrientations
	)
	 */
	private class Arg_GetJointOrientations extends Arg_property {
		private int capacity;
		private Struct_JointOrientation[] jointOrientations;
		
		private Arg_GetJointOrientations(int capacity, Struct_JointOrientation[] jointOrientations) {
			this.capacity = capacity;
			this.jointOrientations = jointOrientations;
		}
	}

	public int GetJointOrientations(int capacity, Struct_JointOrientation[] jointOrientations) throws Exception_KINECT {
		Arg_GetJointOrientations arg = new Arg_GetJointOrientations(capacity, jointOrientations);

		int intRtn = JInvoker.callIntMethod(body, IDX_GetJointOrientations, arg);
		
		System.out.println("GetJointOrientations rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetJointOrientations");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetJointOrientations");

		return intRtn;
	}
	
	/*
	HRESULT GetExpressionDetectionResults(
	         _Pre_equal_to_(Expression_Count)UINT capacity,
	         DetectionResult *detectionResults
	)
	 */
	private class Arg_GetExpressionDetectionResults extends Arg_property {
		private int capacity;
		private int[] detectionResults;
		
		private Arg_GetExpressionDetectionResults(int capacity, int[] detectionResults) {
			this.capacity = capacity;
			this.detectionResults = detectionResults;
		}
	}

	public int GetExpressionDetectionResults(int capacity, int[] detectionResults) throws Exception_KINECT {
		Arg_GetExpressionDetectionResults arg = new Arg_GetExpressionDetectionResults(capacity, detectionResults);

		int intRtn = JInvoker.callIntMethod(body, IDX_GetExpressionDetectionResults, arg);
		
		System.out.println("GetExpressionDetectionResults rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetExpressionDetectionResults");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetExpressionDetectionResults");

		return intRtn;
	}
	
	/*
	HRESULT GetActivityDetectionResults(
	         _Pre_equal_to_(Activity_Count)UINT capacity,
	         DetectionResult *detectionResults
	)
	 */
	private class Arg_GetActivityDetectionResults extends Arg_property {
		private int capacity;
		private int[] detectionResults;
		
		private Arg_GetActivityDetectionResults(int capacity, int[] detectionResults) {
			this.capacity = capacity;
			this.detectionResults = detectionResults;
		}
	}

	public int GetActivityDetectionResults(int capacity, int[] detectionResults) throws Exception_KINECT {
		Arg_GetActivityDetectionResults arg = new Arg_GetActivityDetectionResults(capacity, detectionResults);

		int intRtn = JInvoker.callIntMethod(body, IDX_GetActivityDetectionResults, arg);
		
		System.out.println("GetActivityDetectionResults rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetActivityDetectionResults");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetActivityDetectionResults");

		return intRtn;
	}
	
	/*
	HRESULT GetAppearanceDetectionResults(
	         _Pre_equal_to_(Appearance_Count)UINT capacity,
	         DetectionResult *detectionResults
	)
	 */
	private class Arg_GetAppearanceDetectionResults extends Arg_property {
		private int capacity;
		private int[] detectionResults;
		
		private Arg_GetAppearanceDetectionResults(int capacity, int[] detectionResults) {
			this.capacity = capacity;
			this.detectionResults = detectionResults;
		}
	}

	public int GetAppearanceDetectionResults(int capacity, int[] detectionResults) throws Exception_KINECT {
		Arg_GetAppearanceDetectionResults arg = new Arg_GetAppearanceDetectionResults(capacity, detectionResults);

		int intRtn = JInvoker.callIntMethod(body, IDX_GetAppearanceDetectionResults, arg);
		
		System.out.println("GetAppearanceDetectionResults rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetAppearanceDetectionResults");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetAppearanceDetectionResults");

		return intRtn;
	}
	
	/*
	HRESULT get_HandLeftState(
	         HandState *handState
	)
	 */
	private class Arg_get_HandLeftState extends Arg_property {
		private int[] handState;
		
		private Arg_get_HandLeftState(int[] handState) {
			this.handState = handState;
		}
	}

	public int get_HandLeftState(int[] handState) throws Exception_KINECT {
		Arg_get_HandLeftState arg = new Arg_get_HandLeftState(handState);

		int intRtn = JInvoker.callIntMethod(body, IDX_get_HandLeftState, arg);
		
		System.out.println("get_HandLeftState rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_HandLeftState");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_HandLeftState");

		return intRtn;
	}
	
	/*
	HRESULT get_HandLeftConfidence(
	         TrackingConfidence *confidence
	)
	 */
	private class Arg_get_HandLeftConfidence extends Arg_property {
		private int[] confidence;
		
		private Arg_get_HandLeftConfidence(int[] confidence) {
			this.confidence = confidence;
		}
	}

	public int get_HandLeftConfidence(int[] confidence) throws Exception_KINECT {
		Arg_get_HandLeftConfidence arg = new Arg_get_HandLeftConfidence(confidence);

		int intRtn = JInvoker.callIntMethod(body, IDX_get_HandLeftConfidence, arg);
		
		System.out.println("get_HandLeftConfidence rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_HandLeftConfidence");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_HandLeftConfidence");

		return intRtn;
	}
	
	/*
	HRESULT get_HandRightState(
	         HandState *handState
	)
	 */
	private class Arg_get_HandRightState extends Arg_property {
		private int[] handState;
		
		private Arg_get_HandRightState(int[] handState) {
			this.handState = handState;
		}
	}

	public int get_HandRightState(int[] handState) throws Exception_KINECT {
		Arg_get_HandRightState arg = new Arg_get_HandRightState(handState);

		int intRtn = JInvoker.callIntMethod(body, IDX_get_HandRightState, arg);
		
		System.out.println("get_HandRightState rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_HandRightState");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_HandRightState");

		return intRtn;
	}
	
	/*
	HRESULT get_HandRightConfidence(
	         TrackingConfidence *confidence
	)
	 */
	private class Arg_get_HandRightConfidence extends Arg_property {
		private int[] confidence;
		
		private Arg_get_HandRightConfidence(int[] confidence) {
			this.confidence = confidence;
		}
	}

	public int get_HandRightConfidence(int[] confidence) throws Exception_KINECT {
		Arg_get_HandRightConfidence arg = new Arg_get_HandRightConfidence(confidence);

		int intRtn = JInvoker.callIntMethod(body, IDX_get_HandRightConfidence, arg);
		
		System.out.println("get_HandRightConfidence rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_HandRightConfidence");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_HandRightConfidence");

		return intRtn;
	}
	
	/*
	HRESULT get_TrackingId(
	         UINT64 *trackingId
	)
	 */
	private class Arg_get_TrackingId extends Arg_property {
		private long[] trackingId;
		
		private Arg_get_TrackingId(long[] trackingId) {
			this.trackingId = trackingId;
		}
	}

	public int get_TrackingId(long[] trackingId) throws Exception_KINECT {
		Arg_get_TrackingId arg = new Arg_get_TrackingId(trackingId);

		int intRtn = JInvoker.callIntMethod(body, IDX_get_TrackingId, arg);
		
		System.out.println("get_TrackingId rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_TrackingId");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_TrackingId");

		return intRtn;
	}
	
	/*
	HRESULT get_IsTracked(
	         BOOLEAN *tracked
	)
	 */
	private class Arg_get_IsTracked extends Arg_property {
		private byte[] tracked;
		
		private Arg_get_IsTracked(byte[] tracked) {
			this.tracked = tracked;
		}
	}

	public int get_IsTracked(byte[] tracked) throws Exception_KINECT {
		Arg_get_IsTracked arg = new Arg_get_IsTracked(tracked);

		int intRtn = JInvoker.callIntMethod(body, IDX_get_IsTracked, arg);
		
		System.out.println("get_IsTracked rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_IsTracked");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_IsTracked");

		return intRtn;
	}
	
	/*
	HRESULT get_Lean(
	         PointF *amount
	)
	 */
	private class Arg_get_Lean extends Arg_property {
		private Struct_PointF amount;
		
		private Arg_get_Lean(Struct_PointF amount) {
			this.amount = amount;
		}
	}

	public int get_Lean(Struct_PointF amount) throws Exception_KINECT {
		Arg_get_Lean arg = new Arg_get_Lean(amount);

		int intRtn = JInvoker.callIntMethod(body, IDX_get_Lean, arg);
		
		System.out.println("get_Lean rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_Lean");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_Lean");

		return intRtn;
	}
	
}
