package testkinectv2;

import utildll.*;

public class Wrp_ICoordinateMapper {
	private static final int CHARSET = Arg.UNICODE;
	private long frame = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribeCoordinateMappingChanged = 3,
			IDX_UnsubscribeCoordinateMappingChanged = 4,
			IDX_GetCoordinateMappingChangedEventData = 5,
			IDX_MapCameraPointToDepthSpace = 6,
			IDX_MapCameraPointToColorSpace = 7,
			IDX_MapDepthPointToCameraSpace = 8,
			IDX_MapDepthPointToColorSpace = 9,
			IDX_MapCameraPointsToDepthSpace = 10,
			IDX_MapCameraPointsToColorSpace = 11,
			IDX_MapDepthPointsToCameraSpace = 12,
			IDX_MapDepthPointsToColorSpace = 13,
			IDX_MapDepthFrameToCameraSpace = 14,
			IDX_MapDepthFrameToColorSpace = 15,
			IDX_MapColorFrameToDepthSpace = 16,
			IDX_MapColorFrameToCameraSpace = 17,
			IDX_GetDepthFrameToCameraSpaceTable = 18,
			IDX_GetDepthCameraIntrinsics = 19;
	
	public Wrp_ICoordinateMapper(long frame) {
		this.frame = frame;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(frame, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT MapCameraPointToColorSpace(
	         CameraSpacePoint cameraPoint,
	         ColorSpacePoint *colorPoint
	)
	 */
	private class Arg_MapCameraPointToColorSpace extends Arg_property {
		private Struct_CameraSpacePoint cameraPoint; // @@@@@Œ\̂̈ CameraSpacePoint*ɓǂݑւ
		private Struct_ColorSpacePoint colorPoint;
		
		Arg_MapCameraPointToColorSpace(Struct_CameraSpacePoint cameraPoint, Struct_ColorSpacePoint colorPoint) {
			this.cameraPoint = cameraPoint;
			this.colorPoint = colorPoint;
		}
	}
	
	public int MapCameraPointToColorSpace(Struct_CameraSpacePoint cameraPoint, Struct_ColorSpacePoint colorPoint) throws Exception_KINECT {
		Arg_MapCameraPointToColorSpace arg = new Arg_MapCameraPointToColorSpace(cameraPoint, colorPoint);

		int intRtn = JInvoker.callIntMethod(frame, IDX_MapCameraPointToColorSpace, arg);
		
		//System.out.println("MapCameraPointToColorSpace rtn: " + Integer.toHexString(intRtn)
		//		+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("MapCameraPointToColorSpace");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("MapCameraPointToColorSpace");
		
		return intRtn;
	}

	/*
	HRESULT MapDepthFrameToColorSpace(
	         UINT depthPointCount,
	         const UINT16 *depthFrameData,
	         UINT colorPointCount,
	         ColorSpacePoint *colorSpacePoints
	)
	 */
	private class Arg_MapDepthFrameToColorSpace extends Arg_property {
		private int depthPointCount;
		private @_Const short[] depthFrameData;
		private int colorPointCount;
		private float[] colorSpacePoints; // ColorSpacePoint *
		
		Arg_MapDepthFrameToColorSpace(int depthPointCount, short[] depthFrameData, int colorPointCount,
				float[] colorSpacePoints) {
			this.depthPointCount = depthPointCount;
			this.depthFrameData = depthFrameData;
			this.colorPointCount = colorPointCount;
			this.colorSpacePoints = colorSpacePoints;
		}
	}
	
	public int MapDepthFrameToColorSpace(int depthPointCount, short[] depthFrameData, int colorPointCount,
			float[] colorSpacePoints) throws Exception_KINECT {
		Arg_MapDepthFrameToColorSpace arg = new Arg_MapDepthFrameToColorSpace(depthPointCount, depthFrameData,
				colorPointCount, colorSpacePoints);

		int intRtn = JInvoker.callIntMethod(frame, IDX_MapDepthFrameToColorSpace, arg);
		
		System.out.println("MapDepthFrameToColorSpace rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("MapDepthFrameToColorSpace");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("MapDepthFrameToColorSpace");
		
		return intRtn;
	}
	
	/*
	HRESULT MapColorFrameToDepthSpace(
	         UINT depthDataPointCount,
	         const UINT16 *depthFrameData,
	         UINT depthPointCount,
	         DepthSpacePoint *depthSpacePoints
	)
	 */
	private class Arg_MapColorFrameToDepthSpace extends Arg_property {
		private int depthDataPointCount;
		private @_Const short[] depthFrameData;
		private int depthPointCount;
		private float[] depthSpacePoints; // Struct_DepthSpacePoint[]
		
		Arg_MapColorFrameToDepthSpace(int depthDataPointCount, short[] depthFrameData, int depthPointCount,
				float[] depthSpacePoints) {
			this.depthDataPointCount = depthDataPointCount;
			this.depthFrameData = depthFrameData;
			this.depthPointCount = depthPointCount;
			this.depthSpacePoints = depthSpacePoints;
		}
	}
	
	public int MapColorFrameToDepthSpace(int depthDataPointCount, short[] depthFrameData, int depthPointCount,
			float[] depthSpacePoints) throws Exception_KINECT {
		Arg_MapColorFrameToDepthSpace arg = new Arg_MapColorFrameToDepthSpace(depthDataPointCount, depthFrameData,
				depthPointCount, depthSpacePoints);

		int intRtn = JInvoker.callIntMethod(frame, IDX_MapColorFrameToDepthSpace, arg);
		
		System.out.println("MapColorFrameToDepthSpace rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("MapColorFrameToDepthSpace");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("MapColorFrameToDepthSpace");
		
		return intRtn;
	}
	
}
