package testkinectv2;

import utildll.*;

public class Wrp_IDepthFrameSource {
	private static final int CHARSET = Arg.UNICODE;
	private long source = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribeFrameCaptured = 3,
			IDX_UnsubscribeFrameCaptured = 4,
			IDX_GetFrameCapturedEventData = 5,
			IDX_get_IsActive = 6,
			IDX_OpenReader = 7,
			IDX_get_DepthMinReliableDistance = 8,
			IDX_get_DepthMaxReliableDistance = 9,
			IDX_get_FrameDescription = 10,
			IDX_get_KinectSensor = 11;
	
	public Wrp_IDepthFrameSource(long source) {
		this.source = source;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(source, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT OpenReader(
	         IDepthFrameReader **reader
	)
	 */
	private class Arg_OpenReader extends Arg_property {
		private long[] reader;
		
		private Arg_OpenReader(long[] reader) {
			this.reader = reader;
		}
	}

	public int OpenReader(long[] reader) throws Exception_KINECT {
		Arg_OpenReader arg = new Arg_OpenReader(reader);

		int intRtn = JInvoker.callIntMethod(source, IDX_OpenReader, arg);
		
		System.out.println("OpenReader rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("OpenReader");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("OpenReader");

		return intRtn;
	}

	/*
	HRESULT get_DepthMinReliableDistance(
	         UINT16 *depthMinReliableDistance
	)
	 */
	private class Arg_get_DepthMinReliableDistance extends Arg_property {
		private short[] depthMinReliableDistance;
		
		private Arg_get_DepthMinReliableDistance(short[] depthMinReliableDistance) {
			this.depthMinReliableDistance = depthMinReliableDistance;
		}
	}

	public int get_DepthMinReliableDistance(short[] depthMinReliableDistance) throws Exception_KINECT {
		Arg_get_DepthMinReliableDistance arg = new Arg_get_DepthMinReliableDistance(depthMinReliableDistance);

		int intRtn = JInvoker.callIntMethod(source, IDX_get_DepthMinReliableDistance, arg);
		
		System.out.println("get_DepthMinReliableDistance rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_DepthMinReliableDistance");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_DepthMinReliableDistance");

		return intRtn;
	}
	
	/*
	HRESULT get_DepthMaxReliableDistance(
	         UINT16 *depthMaxReliableDistance
	)
	 */
	private class Arg_get_DepthMaxReliableDistance extends Arg_property {
		private short[] depthMaxReliableDistance;
		
		private Arg_get_DepthMaxReliableDistance(short[] depthMaxReliableDistance) {
			this.depthMaxReliableDistance = depthMaxReliableDistance;
		}
	}

	public int get_DepthMaxReliableDistance(short[] depthMaxReliableDistance) throws Exception_KINECT {
		Arg_get_DepthMaxReliableDistance arg = new Arg_get_DepthMaxReliableDistance(depthMaxReliableDistance);

		int intRtn = JInvoker.callIntMethod(source, IDX_get_DepthMaxReliableDistance, arg);
		
		System.out.println("get_DepthMaxReliableDistance rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_DepthMaxReliableDistance");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_DepthMaxReliableDistance");

		return intRtn;
	}
	
	/*
	HRESULT get_FrameDescription(
	         IFrameDescription **frameDescription
	)
	 */
	private class Arg_get_FrameDescription extends Arg_property {
		private long[] frameDescription;
		
		private Arg_get_FrameDescription(long[] frameDescription) {
			this.frameDescription = frameDescription;
		}
	}

	public int get_FrameDescription(long[] frameDescription) throws Exception_KINECT {
		Arg_get_FrameDescription arg = new Arg_get_FrameDescription(frameDescription);

		int intRtn = JInvoker.callIntMethod(source, IDX_get_FrameDescription, arg);
		
		System.out.println("get_FrameDescription rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_FrameDescription");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_FrameDescription");

		return intRtn;
	}

}
