package testkinectv2;

import utildll.*;

public class Wrp_IFaceFrameSource {
	private static final int CHARSET = Arg.UNICODE;
	private long source = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_get_IsActive = 3,
			IDX_OpenReader = 4,
			IDX_get_KinectSensor = 5,
			IDX_SubscribeTrackingIdLost = 6,
			IDX_UnsubscribeTrackingIdLost = 7,
			IDX_GetTrackingIdLostEventData = 8,
			IDX_get_TrackingId = 9,
			IDX_put_TrackingId = 10,
			IDX_get_IsTrackingIdValid = 11,
			IDX_get_FaceFrameFeatures = 12,
			IDX_put_FaceFrameFeatures = 13;
	
	public Wrp_IFaceFrameSource(long source) {
		this.source = source;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(source, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT OpenReader(
	         IFaceFrameReader **reader
	)
	 */
	private class Arg_OpenReader extends Arg_property {
		private long[] reader;
		
		private Arg_OpenReader(long[] reader) {
			this.reader = reader;
		}
	}

	public int OpenReader(long[] reader) throws Exception_KINECT {
		Arg_OpenReader arg = new Arg_OpenReader(reader);

		int intRtn = JInvoker.callIntMethod(source, IDX_OpenReader, arg);
		
		System.out.println("OpenReader rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("OpenReader");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("OpenReader");

		return intRtn;
	}

	/*
	HRESULT put_TrackingId(
	         const UINT64 trackingId
	)
	 */
	private class Arg_put_TrackingId extends Arg_property {
		private long trackingId;
		
		private Arg_put_TrackingId(long trackingId) {
			this.trackingId = trackingId;
		}
	}

	public int put_TrackingId(long trackingId) throws Exception_KINECT {
		Arg_put_TrackingId arg = new Arg_put_TrackingId(trackingId);

		int intRtn = JInvoker.callIntMethod(source, IDX_put_TrackingId, arg);
		
		System.out.println("put_TrackingId rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("put_TrackingId");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("put_TrackingId");

		return intRtn;
	}

}
