package testkinectv2;

import utildll.*;

public class Wrp_IKinectCoreWindow {
	private static final int CHARSET = Arg.UNICODE;
	private long window = 0;
	private static final int
			IDX_QueryInterface = 0,
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribePointerEntered = 3,
			IDX_UnsubscribePointerEntered = 4,
			IDX_GetPointerEnteredEventData = 5,
			IDX_SubscribePointerMoved = 6,
			IDX_UnsubscribePointerMoved = 7,
			IDX_GetPointerMovedEventData = 8,
			IDX_SubscribePointerExited = 9,
			IDX_UnsubscribePointerExited = 10,
			IDX_GetPointerExitedEventData = 11;
	
	public Wrp_IKinectCoreWindow(long window) {
		this.window = window;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(window, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT SubscribePointerEntered(
	         WAITABLE_HANDLE *waitableHandle
	)
	 */
	private class Arg_SubscribePointerEntered extends Arg_property {
		private long[] waitableHandle;
		
		private Arg_SubscribePointerEntered(long[] waitableHandle) {
			this.waitableHandle = waitableHandle;
		}
	}

	public int SubscribePointerEntered(long[] waitableHandle) throws Exception_KINECT {
		Arg_SubscribePointerEntered arg = new Arg_SubscribePointerEntered(waitableHandle);

		int intRtn = JInvoker.callIntMethod(window, IDX_SubscribePointerEntered, arg);
		
		System.out.println("SubscribePointerEntered rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("SubscribePointerEntered");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("SubscribePointerEntered");

		return intRtn;
	}

	/*
	HRESULT UnsubscribePointerEntered(
	         WAITABLE_HANDLE waitableHandle
	)
	 */
	private class Arg_UnsubscribePointerEntered extends Arg_property {
		private long waitableHandle;
		
		private Arg_UnsubscribePointerEntered(long waitableHandle) {
			this.waitableHandle = waitableHandle;
		}
	}

	public int UnsubscribePointerEntered(long waitableHandle) throws Exception_KINECT {
		Arg_UnsubscribePointerEntered arg = new Arg_UnsubscribePointerEntered(waitableHandle);

		int intRtn = JInvoker.callIntMethod(window, IDX_UnsubscribePointerEntered, arg);
		
		System.out.println("UnsubscribePointerEntered rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("UnsubscribePointerEntered");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("UnsubscribePointerEntered");

		return intRtn;
	}
	
	/*
	HRESULT SubscribePointerMoved(
	         WAITABLE_HANDLE *waitableHandle
	)
	 */
	private class Arg_SubscribePointerMoved extends Arg_property {
		private long[] waitableHandle;
		
		private Arg_SubscribePointerMoved(long[] waitableHandle) {
			this.waitableHandle = waitableHandle;
		}
	}

	public int SubscribePointerMoved(long[] waitableHandle) throws Exception_KINECT {
		Arg_SubscribePointerMoved arg = new Arg_SubscribePointerMoved(waitableHandle);

		int intRtn = JInvoker.callIntMethod(window, IDX_SubscribePointerMoved, arg);
		
		System.out.println("SubscribePointerMoved rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("SubscribePointerMoved");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("SubscribePointerMoved");

		return intRtn;
	}
	
	/*
	HRESULT UnsubscribePointerMoved(
	         WAITABLE_HANDLE waitableHandle
	)
	 */
	private class Arg_UnsubscribePointerMoved extends Arg_property {
		private long waitableHandle;
		
		private Arg_UnsubscribePointerMoved(long waitableHandle) {
			this.waitableHandle = waitableHandle;
		}
	}

	public int UnsubscribePointerMoved(long waitableHandle) throws Exception_KINECT {
		Arg_UnsubscribePointerMoved arg = new Arg_UnsubscribePointerMoved(waitableHandle);

		int intRtn = JInvoker.callIntMethod(window, IDX_UnsubscribePointerMoved, arg);
		
		System.out.println("UnsubscribePointerMoved rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("UnsubscribePointerMoved");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("UnsubscribePointerMoved");

		return intRtn;
	}
	
	/*
	HRESULT GetPointerMovedEventData(
	         WAITABLE_HANDLE waitableHandle,
	         IKinectPointerEventArgs **eventData
	)
	 */
	private class Arg_GetPointerMovedEventData extends Arg_property {
		private long waitableHandle;
		private long[] eventData;
		
		private Arg_GetPointerMovedEventData(long waitableHandle, long[] eventData) {
			this.waitableHandle = waitableHandle;
			this.eventData = eventData;
		}
	}

	public int GetPointerMovedEventData(long waitableHandle, long[] eventData) throws Exception_KINECT {
		Arg_GetPointerMovedEventData arg = new Arg_GetPointerMovedEventData(waitableHandle, eventData);

		int intRtn = JInvoker.callIntMethod(window, IDX_GetPointerMovedEventData, arg);
		
		System.out.println("GetPointerMovedEventData rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetPointerMovedEventData");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetPointerMovedEventData");

		return intRtn;
	}
	
	/*
	HRESULT SubscribePointerExited(
	         WAITABLE_HANDLE *waitableHandle
	)
	 */
	private class Arg_SubscribePointerExited extends Arg_property {
		private long[] waitableHandle;
		
		private Arg_SubscribePointerExited(long[] waitableHandle) {
			this.waitableHandle = waitableHandle;
		}
	}

	public int SubscribePointerExited(long[] waitableHandle) throws Exception_KINECT {
		Arg_SubscribePointerExited arg = new Arg_SubscribePointerExited(waitableHandle);

		int intRtn = JInvoker.callIntMethod(window, IDX_SubscribePointerExited, arg);
		
		System.out.println("SubscribePointerExited rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("SubscribePointerExited");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("SubscribePointerExited");

		return intRtn;
	}

	/*
	HRESULT UnsubscribePointerExited(
	         WAITABLE_HANDLE waitableHandle
	)
	 */
	private class Arg_UnsubscribePointerExited extends Arg_property {
		private long waitableHandle;
		
		private Arg_UnsubscribePointerExited(long waitableHandle) {
			this.waitableHandle = waitableHandle;
		}
	}

	public int UnsubscribePointerExited(long waitableHandle) throws Exception_KINECT {
		Arg_UnsubscribePointerExited arg = new Arg_UnsubscribePointerExited(waitableHandle);

		int intRtn = JInvoker.callIntMethod(window, IDX_UnsubscribePointerExited, arg);
		
		System.out.println("UnsubscribePointerExited rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("UnsubscribePointerExited");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("UnsubscribePointerExited");

		return intRtn;
	}
	
}
