package testkinectv2;

import utildll.*;

public class Wrp_IKinectSensor {
	private static final int CHARSET = Arg.UNICODE;
	private long sensor = 0;
	private static final int
			IDX_QueryInterface = 0, 
			IDX_AddRef = 1,
			IDX_Release = 2,
			IDX_SubscribeIsAvailableChanged = 3,
			IDX_UnsubscribeIsAvailableChanged = 4,
			IDX_GetIsAvailableChangedEventData = 5,
			IDX_Open = 6,
			IDX_Close = 7,
			IDX_get_IsOpen = 8,
			IDX_get_IsAvailable = 9,
			IDX_get_ColorFrameSource = 10,
			IDX_get_DepthFrameSource = 11,
			IDX_get_BodyFrameSource = 12,
			IDX_get_BodyIndexFrameSource = 13,
			IDX_get_InfraredFrameSource = 14,
			IDX_get_LongExposureInfraredFrameSource = 15,
			IDX_get_AudioSource = 16,
			IDX_OpenMultiSourceFrameReader = 17,
			IDX_get_CoordinateMapper = 18,
			IDX_get_UniqueKinectId = 19,
			IDX_get_KinectCapabilities = 20; 
	
	public Wrp_IKinectSensor(long sensor) {
		this.sensor = sensor;
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	private class Arg_Release extends Arg_property {
	}
	
	public int Release() throws Exception_KINECT {
		Arg_Release arg = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(sensor, IDX_Release, arg);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT Open()
	 */
	private class Arg_Open extends Arg_property {
	}

	public int Open() throws Exception_KINECT {
		Arg_Open arg = new Arg_Open();

		int intRtn = JInvoker.callIntMethod(sensor, IDX_Open, arg);
		
		System.out.println("Open rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Open");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Open");

		return intRtn;
	}
	
	/*
	HRESULT Close()
	 */
	private class Arg_Close extends Arg_property {
	}

	public int Close() throws Exception_KINECT {
		Arg_Close arg = new Arg_Close();

		int intRtn = JInvoker.callIntMethod(sensor, IDX_Close, arg);
		
		System.out.println("Close rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("Close");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Close");

		return intRtn;
	}
	
	/*
	HRESULT get_ColorFrameSource(
	         IColorFrameSource **colorFrameSource
	)
	 */
	private class Arg_get_ColorFrameSource extends Arg_property {
		private long[] colorFrameSource;
		
		private Arg_get_ColorFrameSource(long[] colorFrameSource) {
			this.colorFrameSource = colorFrameSource;
		}
	}

	public int get_ColorFrameSource(long[] colorFrameSource) throws Exception_KINECT {
		Arg_get_ColorFrameSource arg = new Arg_get_ColorFrameSource(colorFrameSource);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_get_ColorFrameSource, arg);
		
		System.out.println("get_ColorFrameSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_ColorFrameSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_ColorFrameSource");

		return intRtn;
	}
	
	/*
	HRESULT get_DepthFrameSource(
	         IDepthFrameSource **depthFrameSource
	)
	 */
	private class Arg_get_DepthFrameSource extends Arg_property {
		private long[] depthFrameSource;
		
		private Arg_get_DepthFrameSource(long[] depthFrameSource) {
			this.depthFrameSource = depthFrameSource;
		}
	}

	public int get_DepthFrameSource(long[] depthFrameSource) throws Exception_KINECT {
		Arg_get_DepthFrameSource arg = new Arg_get_DepthFrameSource(depthFrameSource);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_get_DepthFrameSource, arg);
		
		System.out.println("get_DepthFrameSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_DepthFrameSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_DepthFrameSource");

		return intRtn;
	}
	
	/*
	HRESULT get_BodyFrameSource(
	         IBodyFrameSource **bodyFrameSource
	)
	 */
	private class Arg_get_BodyFrameSource extends Arg_property {
		private long[] bodyFrameSource;
		
		private Arg_get_BodyFrameSource(long[] bodyFrameSource) {
			this.bodyFrameSource = bodyFrameSource;
		}
	}

	public int get_BodyFrameSource(long[] bodyFrameSource) throws Exception_KINECT {
		Arg_get_BodyFrameSource arg = new Arg_get_BodyFrameSource(bodyFrameSource);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_get_BodyFrameSource, arg);
		
		System.out.println("get_BodyFrameSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_BodyFrameSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_BodyFrameSource");

		return intRtn;
	}
	
	/*
	HRESULT get_BodyIndexFrameSource(
	         IBodyIndexFrameSource **bodyIndexFrameSource
	)
	 */
	private class Arg_get_BodyIndexFrameSource extends Arg_property {
		private long[] bodyIndexFrameSource;
		
		private Arg_get_BodyIndexFrameSource(long[] bodyIndexFrameSource) {
			this.bodyIndexFrameSource = bodyIndexFrameSource;
		}
	}

	public int get_BodyIndexFrameSource(long[] bodyIndexFrameSource) throws Exception_KINECT {
		Arg_get_BodyIndexFrameSource arg = new Arg_get_BodyIndexFrameSource(bodyIndexFrameSource);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_get_BodyIndexFrameSource, arg);
		
		System.out.println("get_BodyIndexFrameSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_BodyIndexFrameSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_BodyIndexFrameSource");

		return intRtn;
	}
	
	/*
	HRESULT get_InfraredFrameSource(
	         IInfraredFrameSource **infraredFrameSource
	)
	 */
	private class Arg_get_InfraredFrameSource extends Arg_property {
		private long[] infraredFrameSource;
		
		private Arg_get_InfraredFrameSource(long[] infraredFrameSource) {
			this.infraredFrameSource = infraredFrameSource;
		}
	}

	public int get_InfraredFrameSource(long[] infraredFrameSource) throws Exception_KINECT {
		Arg_get_InfraredFrameSource arg = new Arg_get_InfraredFrameSource(infraredFrameSource);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_get_InfraredFrameSource, arg);
		
		System.out.println("get_InfraredFrameSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_InfraredFrameSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_InfraredFrameSource");

		return intRtn;
	}

	/*
	HRESULT get_LongExposureInfraredFrameSource(
	         ILongExposureInfraredFrameSource **longExposureInfraredFrameSource
	)
	 */
	private class Arg_get_LongExposureInfraredFrameSource extends Arg_property {
		private long[] longExposureInfraredFrameSource;
		
		private Arg_get_LongExposureInfraredFrameSource(long[] longExposureInfraredFrameSource) {
			this.longExposureInfraredFrameSource = longExposureInfraredFrameSource;
		}
	}

	public int get_LongExposureInfraredFrameSource(long[] longExposureInfraredFrameSource) throws Exception_KINECT {
		Arg_get_LongExposureInfraredFrameSource arg = new Arg_get_LongExposureInfraredFrameSource(longExposureInfraredFrameSource);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_get_LongExposureInfraredFrameSource, arg);
		
		System.out.println("get_LongExposureInfraredFrameSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_LongExposureInfraredFrameSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_LongExposureInfraredFrameSource");

		return intRtn;
	}
	
	/*
	HRESULT get_AudioSource(
	         IAudioSource **audioSource
	)
	 */
	private class Arg_get_AudioSource extends Arg_property {
		private long[] audioSource;
		
		private Arg_get_AudioSource(long[] audioSource) {
			this.audioSource = audioSource;
		}
	}

	public int get_AudioSource(long[] audioSource) throws Exception_KINECT {
		Arg_get_AudioSource arg = new Arg_get_AudioSource(audioSource);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_get_AudioSource, arg);
		
		System.out.println("get_AudioSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_AudioSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_AudioSource");

		return intRtn;
	}
	
	/*
	HRESULT OpenMultiSourceFrameReader(
	         DWORD enabledFrameSourceTypes,
	         IMultiSourceFrameReader **multiSourceFrameReader
	)
	 */
	private class Arg_OpenMultiSourceFrameReader extends Arg_property {
		private int enabledFrameSourceTypes;
		private long[] multiSourceFrameReader;
		
		private Arg_OpenMultiSourceFrameReader(int enabledFrameSourceTypes, long[] multiSourceFrameReader) {
			this.enabledFrameSourceTypes = enabledFrameSourceTypes;
			this.multiSourceFrameReader = multiSourceFrameReader;
		}
	}

	public int OpenMultiSourceFrameReader(int enabledFrameSourceTypes, long[] multiSourceFrameReader) throws Exception_KINECT {
		Arg_OpenMultiSourceFrameReader arg = new Arg_OpenMultiSourceFrameReader(enabledFrameSourceTypes, 
				multiSourceFrameReader);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_OpenMultiSourceFrameReader, arg);
		
		System.out.println("OpenMultiSourceFrameReader rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("OpenMultiSourceFrameReader");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("OpenMultiSourceFrameReader");

		return intRtn;
	}
	
	/*
	HRESULT get_CoordinateMapper(
	         ICoordinateMapper **coordinateMapper
	)
	 */
	private class Arg_get_CoordinateMapper extends Arg_property {
		private long[] coordinateMapper;
		
		private Arg_get_CoordinateMapper(long[] coordinateMapper) {
			this.coordinateMapper = coordinateMapper;
		}
	}

	public int get_CoordinateMapper(long[] coordinateMapper) throws Exception_KINECT {
		Arg_get_CoordinateMapper arg = new Arg_get_CoordinateMapper(coordinateMapper);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_get_CoordinateMapper, arg);
		
		System.out.println("get_CoordinateMapper rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("get_CoordinateMapper");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("get_CoordinateMapper");

		return intRtn;
	}
	
}
