package testkinectv2;

import utildll.*;

public class Wrp_JInvoker {
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	private class Arg_allocFunc extends Arg_property {
		private @_FuncPtr Object obj;
		
		Arg_allocFunc(Object obj) {
			this.obj = obj;
		}
	}
	
	public long allocFunc(Object obj) throws Exception_JInvoker {
		Arg_allocFunc arg = new Arg_allocFunc(obj);
		
		long adrs = JInvoker.allocObject(arg);
		
		System.out.println("allocFunc allocAdrs: " + Long.toHexString(adrs)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (arg.getLastError() != 0) throw new Exception_JInvoker("allocFunc");
		
		return adrs;
	}

	private class Arg_allocStruct extends Arg_property {
		private Object obj;
		
		Arg_allocStruct(Object obj) {
			this.obj = obj;
		}
	}
	
	public long allocStruct(Object obj) throws Exception_JInvoker {
		Arg_allocStruct arg = new Arg_allocStruct(obj);
		
		long adrs = JInvoker.allocObject(arg);
		
		System.out.println("allocStruct allocAdrs: " + Long.toHexString(adrs)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (arg.getLastError() != 0) throw new Exception_JInvoker("allocStruct");
		
		return adrs;
	}

	public int freeObject(long adrs) {
		int intRtnVal = JInvoker.freeObject(adrs);
		
		System.out.println("freeObject intRtnVal: " + Integer.toString(intRtnVal));

		return intRtnVal;
	}
	
	private class Arg_movePtrToStruct extends Arg_property {
		private Object obj;
		
		Arg_movePtrToStruct(Object obj) {
			this.obj = obj;
		}
	}

	public int movePtrToStruct(Object obj, long ptr) throws Exception_JInvoker {
		Arg_movePtrToStruct arg = new Arg_movePtrToStruct(obj);
		
		int intRtn = JInvoker.movePtrToObject(arg, ptr);
		
		System.out.println("movePtrToStruct rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (arg.getLastError() != 0) throw new Exception_JInvoker("movePtrToStruct");

		return intRtn;
	}
	
	private class Arg_sizeof extends Arg_property {
		private @_Const Object obj;

		Arg_sizeof(Object obj) {
			this.obj = obj;
		}
	}

	public long sizeof(Object obj) throws Exception_JInvoker {
		Arg_sizeof arg = new Arg_sizeof(obj);
		
		long lngSize = JInvoker.sizeof(arg);
		
		System.out.println("sizeof rtn: " + Long.toString(lngSize)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (arg.getLastError() != 0) throw new Exception_JInvoker("sizeof");
		
		return lngSize;
	}

	private class Arg_movePtrToByteArray extends Arg_property {
		private byte[] ab;
		
		Arg_movePtrToByteArray(byte[] ab) {
			this.ab = ab;
		}
	}

	public int movePtrToByteArray(byte[] ab, long ptr) throws Exception_JInvoker {
		Arg_movePtrToByteArray arg = new Arg_movePtrToByteArray(ab);
		
		int intRtn = JInvoker.movePtrToObject(arg, ptr);
		
		System.out.println("movePtrToByteArray rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (arg.getLastError() != 0) throw new Exception_JInvoker("movePtrToByteArray");
		
		return intRtn;
	}

	private class Arg_movePtrToIntArray extends Arg_property {
		private int[] ai;
		
		Arg_movePtrToIntArray(int[] ai) {
			this.ai = ai;
		}
	}

	public int movePtrToIntArray(int[] ai, long ptr) throws Exception_JInvoker {
		Arg_movePtrToIntArray arg = new Arg_movePtrToIntArray(ai);
		
		int intRtn = JInvoker.movePtrToObject(arg, ptr);
		
		System.out.println("movePtrToIntArray rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (arg.getLastError() != 0) throw new Exception_JInvoker("movePtrToIntArray");

		return intRtn;
	}

	private class Arg_movePtrToShortArray extends Arg_property {
		private short[] as;
		
		Arg_movePtrToShortArray(short[] as) {
			this.as = as;
		}
	}

	public int movePtrToShortArray(short[] as, long ptr) throws Exception_JInvoker {
		Arg_movePtrToShortArray arg = new Arg_movePtrToShortArray(as);
		
		int intRtn = JInvoker.movePtrToObject(arg, ptr);
		
		System.out.println("movePtrToShortArray rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (arg.getLastError() != 0) throw new Exception_JInvoker("movePtrToShortArray");

		return intRtn;
	}

	private class Arg_movePtrToFloatArray extends Arg_property {
		private float[] af;
		
		Arg_movePtrToFloatArray(float[] af) {
			this.af = af;
		}
	}

	public int movePtrToFloatArray(float[] af, long ptr) throws Exception_JInvoker {
		Arg_movePtrToFloatArray arg = new Arg_movePtrToFloatArray(af);
		
		int intRtn = JInvoker.movePtrToObject(arg, ptr);
		
		System.out.println("movePtrToFloatArray rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (arg.getLastError() != 0) throw new Exception_JInvoker("movePtrToFloatArray");

		return intRtn;
	}

	private class Arg_moveIntArrayToPtr extends Arg_property {
		private int[] ai;
		
		Arg_moveIntArrayToPtr(int[] ai) {
			this.ai = ai;
		}
	}

	public int moveIntArrayToPtr(long ptr, int[] ai) throws Exception_JInvoker {
		Arg_moveIntArrayToPtr arg = new Arg_moveIntArrayToPtr(ai);
		
		int intRtn = JInvoker.moveObjectToPtr(ptr, arg);
		
		System.out.println("moveIntArrayToPtr rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (arg.getLastError() != 0) throw new Exception_JInvoker("moveIntArrayToPtr");

		return intRtn;
	}

}
