package testkinectv2;

import utildll.*;

public class Wrp_KINECTV2 {
	private static final int CHARSET = Arg.UNICODE;
	private static final String KINECT_DLL_NAME = "Kinect20";
	private String[] strFncName = {
			"GetDefaultKinectSensor",
			"GetKinectCoreWindowForCurrentThread"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_GetDefaultKinectSensor = 0,
			IDX_GetKinectCoreWindowForCurrentThread = 1;
	private long hMod = 0;
	
	public Wrp_KINECTV2() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(KINECT_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " strFncName: " + strFncName[i]);
		}
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HRESULT GetDefaultKinectSensor(
	         IKinectSensor **defaultKinectSensor
	)
	 */
	private class Arg_GetDefaultKinectSensor extends Arg_property {
		private long[] defaultKinectSensor;

		Arg_GetDefaultKinectSensor(long[] defaultKinectSensor) {
			this.defaultKinectSensor = defaultKinectSensor;
		}
	}
	
	public int GetDefaultKinectSensor(long[] defaultKinectSensor) throws Exception_KINECT {
		Arg_GetDefaultKinectSensor arg = new Arg_GetDefaultKinectSensor(defaultKinectSensor);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_GetDefaultKinectSensor], arg);
		
		System.out.println("GetDefaultKinectSensor rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetDefaultKinectSensor");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetDefaultKinectSensor");
		
		return intRtn;
	}
	
	/*
	HRESULT GetKinectCoreWindowForCurrentThread(
	         IKinectCoreWindow **ppKinectCoreWindow
	)
	 */
	private class Arg_GetKinectCoreWindowForCurrentThread extends Arg_property {
		private long[] ppKinectCoreWindow;

		Arg_GetKinectCoreWindowForCurrentThread(long[] ppKinectCoreWindow) {
			this.ppKinectCoreWindow = ppKinectCoreWindow;
		}
	}
	
	public int GetKinectCoreWindowForCurrentThread(long[] ppKinectCoreWindow) throws Exception_KINECT {
		Arg_GetKinectCoreWindowForCurrentThread arg = new Arg_GetKinectCoreWindowForCurrentThread(ppKinectCoreWindow);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_GetKinectCoreWindowForCurrentThread], arg);
		
		System.out.println("GetKinectCoreWindowForCurrentThread rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetKinectCoreWindowForCurrentThread");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetKinectCoreWindowForCurrentThread");
		
		return intRtn;
	}

	
	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	private class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	private class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	private class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}
	
}
