package testkinectv2;

import utildll.*;

public class Wrp_KINECTV2FACE {
	private static final int CHARSET = Arg.UNICODE;
	private static final String KINECT_FACE_DLL_NAME = "Kinect20.Face.dll";
	private String[] strFncName = {
			"CreateFaceAlignment",
			"CreateFaceFrameSource",
			"CreateFaceModel",
			"CreateHighDefinitionFaceFrameSource",
			"GetFaceModelVertexCount"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_CreateFaceAlignment = 0,
			IDX_CreateFaceFrameSource = 1,
			IDX_CreateFaceModel = 2,
			IDX_CreateHighDefinitionFaceFrameSource = 3,
			IDX_GetFaceModelVertexCount = 4;
	private long hMod = 0;
	
	public Wrp_KINECTV2FACE() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(KINECT_FACE_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " strFncName: " + strFncName[i]);
		}
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HRESULT CreateFaceAlignment(
	         IFaceAlignment **ppFaceAlignment
	)
	 */
	private class Arg_CreateFaceAlignment extends Arg_property {
		private long[] ppFaceAlignment;

		Arg_CreateFaceAlignment(long[] ppFaceAlignment) {
			this.ppFaceAlignment = ppFaceAlignment;
		}
	}
	
	public int CreateFaceAlignment(long[] ppFaceAlignment) throws Exception_KINECT {
		Arg_CreateFaceAlignment arg = new Arg_CreateFaceAlignment(ppFaceAlignment);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_CreateFaceAlignment], arg);
		
		System.out.println("CreateFaceAlignment rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CreateFaceAlignment");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CreateFaceAlignment");
		
		return intRtn;
	}
	
	/*
	HRESULT CreateFaceFrameSource(
	         IKinectSensor *sensor,
	         const UINT64 initialTrackingId,
	         const DWORD initialFaceFrameFeatures,
	         IFaceFrameSource **ppSource
	)
	 */
	private class Arg_CreateFaceFrameSource extends Arg_property {
		private long sensor;
		private long initialTrackingId;
		private int initialFaceFrameFeatures;
		private long[] ppSource;

		Arg_CreateFaceFrameSource(long sensor, long initialTrackingId, int initialFaceFrameFeatures, long[] ppSource) {
			this.sensor = sensor;
			this.initialTrackingId = initialTrackingId;
			this.initialFaceFrameFeatures = initialFaceFrameFeatures;
			this.ppSource = ppSource;
		}
	}
	
	public int CreateFaceFrameSource(long sensor, long initialTrackingId, int initialFaceFrameFeatures,
			long[] ppSource) throws Exception_KINECT {
		Arg_CreateFaceFrameSource arg = new Arg_CreateFaceFrameSource(sensor, initialTrackingId,
				initialFaceFrameFeatures, ppSource);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_CreateFaceFrameSource], arg);
		
		System.out.println("CreateFaceFrameSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CreateFaceFrameSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CreateFaceFrameSource");
		
		return intRtn;
	}
	
	/*
	HRESULT CreateFaceModel(
	         float scale,
	         UINT32 capacity,
	         float *pDeformations,
	         IFaceModel **ppFaceModel
	)
	 */
	private class Arg_CreateFaceModel extends Arg_property {
		private float scale;
		private int capacity;
		private float[] pDeformations;
		private long[] ppFaceModel;

		Arg_CreateFaceModel(float scale, int capacity, float[] pDeformations, long[] ppFaceModel) {
			this.scale = scale;
			this.capacity = capacity;
			this.pDeformations = pDeformations;
			this.ppFaceModel = ppFaceModel;
		}
	}
	
	public int CreateFaceModel(float scale, int capacity, float[] pDeformations, long[] ppFaceModel) throws Exception_KINECT {
		Arg_CreateFaceModel arg = new Arg_CreateFaceModel(scale, capacity, pDeformations, ppFaceModel);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_CreateFaceModel], arg);
		
		System.out.println("CreateFaceModel rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CreateFaceModel");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CreateFaceModel");
		
		return intRtn;
	}
	
	/*
	HRESULT CreateHighDefinitionFaceFrameSource(
	         IKinectSensor *sensor,
	         IHighDefinitionFaceFrameSource **hdFaceFrameSource
	)
	 */
	private class Arg_CreateHighDefinitionFaceFrameSource extends Arg_property {
		private long sensor;
		private long[] hdFaceFrameSource;

		Arg_CreateHighDefinitionFaceFrameSource(long sensor, long[] hdFaceFrameSource) {
			this.sensor = sensor;
			this.hdFaceFrameSource = hdFaceFrameSource;
		}
	}
	
	public int CreateHighDefinitionFaceFrameSource(long sensor, long[] hdFaceFrameSource) throws Exception_KINECT {
		Arg_CreateHighDefinitionFaceFrameSource arg = new Arg_CreateHighDefinitionFaceFrameSource(sensor, hdFaceFrameSource);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_CreateHighDefinitionFaceFrameSource], arg);
		
		System.out.println("CreateHighDefinitionFaceFrameSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CreateHighDefinitionFaceFrameSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CreateHighDefinitionFaceFrameSource");
		
		return intRtn;
	}
	
	/*
	HRESULT GetFaceModelVertexCount(
	         UINT32 *pVertexCount
	)
	 */
	private class Arg_GetFaceModelVertexCount extends Arg_property {
		private int[] pVertexCount;

		Arg_GetFaceModelVertexCount(int[] pVertexCount) {
			this.pVertexCount = pVertexCount;
		}
	}
	
	public int GetFaceModelVertexCount(int[] pVertexCount) throws Exception_KINECT {
		Arg_GetFaceModelVertexCount arg = new Arg_GetFaceModelVertexCount(pVertexCount);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_GetFaceModelVertexCount], arg);
		
		System.out.println("GetFaceModelVertexCount rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("GetFaceModelVertexCount");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetFaceModelVertexCount");
		
		return intRtn;
	}
	
	
	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	private class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	private class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	private class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}

}
