package testkinectv2;

import utildll.*;

public class Wrp_KINECTV2GESTURE {
	private static final int CHARSET = Arg.UNICODE;
	private static final String KINECT_GESTURE_DLL_NAME = "Kinect20.VisualGestureBuilder.dll";
	private String[] strFncName = {
			"CreateVisualGestureBuilderFrameSource",
			"CreateVisualGestureBuilderDatabaseInstanceFromFile"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_CreateVisualGestureBuilderFrameSource = 0,
			IDX_CreateVisualGestureBuilderDatabaseInstanceFromFile = 1;
	private long hMod = 0;
	
	public Wrp_KINECTV2GESTURE() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(KINECT_GESTURE_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " strFncName: " + strFncName[i]);
		}
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HRESULT CreateVisualGestureBuilderFrameSource(
	         IKinectSensor *sensor,
	         UINT64 initialTrackingId,
	         IVisualGestureBuilderFrameSource **source
	)
	 */
	private class Arg_CreateVisualGestureBuilderFrameSource extends Arg_property {
		private long sensor;
		private long initialTrackingId;
		private long[] source;

		Arg_CreateVisualGestureBuilderFrameSource(long sensor, long initialTrackingId, long[] source) {
			this.sensor = sensor;
			this.initialTrackingId = initialTrackingId;
			this.source = source;
		}
	}
	
	public int CreateVisualGestureBuilderFrameSource(long sensor, long initialTrackingId, long[] source) throws Exception_KINECT {
		Arg_CreateVisualGestureBuilderFrameSource arg = new Arg_CreateVisualGestureBuilderFrameSource(sensor,
				initialTrackingId, source);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_CreateVisualGestureBuilderFrameSource], arg);
		
		System.out.println("CreateVisualGestureBuilderFrameSource rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CreateVisualGestureBuilderFrameSource");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CreateVisualGestureBuilderFrameSource");
		
		return intRtn;
	}
	
	/*
	HRESULT CreateVisualGestureBuilderDatabaseInstanceFromFile(
	         const wchar_t *name,
	         IVisualGestureBuilderDatabase **instance
	)
	 */
	private class Arg_CreateVisualGestureBuilderDatabaseInstanceFromFile extends Arg_property {
		private @_Const @_Unicode String name;
		private long[] instance;

		Arg_CreateVisualGestureBuilderDatabaseInstanceFromFile(String name, long[] instance) {
			this.name = name;
			this.instance = instance;
		}
	}
	
	public int CreateVisualGestureBuilderDatabaseInstanceFromFile(String name, long[] instance) throws Exception_KINECT {
		Arg_CreateVisualGestureBuilderDatabaseInstanceFromFile arg 
				= new Arg_CreateVisualGestureBuilderDatabaseInstanceFromFile(name, instance);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_CreateVisualGestureBuilderDatabaseInstanceFromFile], arg);
		
		System.out.println("CreateVisualGestureBuilderDatabaseInstanceFromFile rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("CreateVisualGestureBuilderDatabaseInstanceFromFile");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CreateVisualGestureBuilderDatabaseInstanceFromFile");
		
		return intRtn;
	}
	
	
	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	private class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	private class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	private class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}

}
