package testkinectv2;

import utildll.*;

public class Wrp_KinectFusion {
	private static final int CHARSET = Arg.UNICODE;
	private static final String FUSION_DLL_NAME = "Kinect20.Fusion.dll";
	private String[] strFncName = {
			"NuiFusionAlignPointClouds",
			"NuiFusionCreateCameraPoseFinder",
			"NuiFusionCreateColorReconstruction",
			"NuiFusionCreateImageFrame",
			"NuiFusionCreateReconstruction",
			"NuiFusionDepthFloatFrameToPointCloud",
			"NuiFusionDepthToDepthFloatFrame",
			"NuiFusionGetDeviceInfo",
			"NuiFusionReleaseImageFrame",
			"NuiFusionShadePointCloud"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_NuiFusionAlignPointClouds = 0,
			IDX_NuiFusionCreateCameraPoseFinder = 1,
			IDX_NuiFusionCreateColorReconstruction = 2,
			IDX_NuiFusionCreateImageFrame = 3,
			IDX_NuiFusionCreateReconstruction = 4,
			IDX_NuiFusionDepthFloatFrameToPointCloud = 5,
			IDX_NuiFusionDepthToDepthFloatFrame = 6,
			IDX_NuiFusionGetDeviceInfo = 7,
			IDX_NuiFusionReleaseImageFrame = 8,
			IDX_NuiFusionShadePointCloud = 9;
	private long hMod = 0;
	
	public Wrp_KinectFusion() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(FUSION_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " strFncName: " + strFncName[i]);
		}
	}
	
	private class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HRESULT NuiFusionCreateColorReconstruction(
	         const NUI_FUSION_RECONSTRUCTION_PARAMETERS *pReconstructionParameters,
	         NUI_FUSION_RECONSTRUCTION_PROCESSOR_TYPE reconstructionProcessorType,
	         INT deviceIndex,
	         const Matrix4 *pInitialWorldToCameraTransform,
	         INuiFusionColorReconstruction **ppNuiFusionColorReconstruction
	)
	 */
	private class Arg_NuiFusionCreateColorReconstruction extends Arg_property {
		private @_Const Struct_NUI_FUSION_RECONSTRUCTION_PARAMETERS pReconstructionParameters;
		private int reconstructionProcessorType;
		private int deviceIndex;
		private @_Const Struct_Matrix4 pInitialWorldToCameraTransform;
		private long[] ppNuiFusionColorReconstruction; // INuiFusionColorReconstruction **

		Arg_NuiFusionCreateColorReconstruction(Struct_NUI_FUSION_RECONSTRUCTION_PARAMETERS pReconstructionParameters,
				int reconstructionProcessorType, int deviceIndex, Struct_Matrix4 pInitialWorldToCameraTransform,
				long[] ppNuiFusionColorReconstruction) {
			this.pReconstructionParameters = pReconstructionParameters;
			this.reconstructionProcessorType = reconstructionProcessorType;
			this.deviceIndex = deviceIndex;
			this.pInitialWorldToCameraTransform = pInitialWorldToCameraTransform;
			this.ppNuiFusionColorReconstruction = ppNuiFusionColorReconstruction;
		}
	}
	
	public int NuiFusionCreateColorReconstruction(Struct_NUI_FUSION_RECONSTRUCTION_PARAMETERS pReconstructionParameters,
			int reconstructionProcessorType, int deviceIndex, Struct_Matrix4 pInitialWorldToCameraTransform,
			long[] ppNuiFusionColorReconstruction) throws Exception_KINECT {
		Arg_NuiFusionCreateColorReconstruction arg = new Arg_NuiFusionCreateColorReconstruction(
				pReconstructionParameters, reconstructionProcessorType, deviceIndex,
				pInitialWorldToCameraTransform, ppNuiFusionColorReconstruction);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionCreateColorReconstruction], arg);
		
		System.out.println("NuiFusionCreateColorReconstruction rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("NuiFusionCreateColorReconstruction");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionCreateColorReconstruction");
		
		return intRtn;
	}
	
	/*
	HRESULT NuiFusionCreateImageFrame(
		NUI_FUSION_IMAGE_TYPE frameType,
		UINT width,
		UINT height,
		const NUI_FUSION_CAMERA_PARAMETERS *pCameraParameters,
		NUI_FUSION_IMAGE_FRAME **ppImageFrame
	)
	 */
	private class Arg_NuiFusionCreateImageFrame extends Arg_property {
		private int frameType;
		private int width;
		private int height;
		private @_Const Struct_NUI_FUSION_CAMERA_PARAMETERS pCameraParameters;
		private long[] ppImageFrame; // NUI_FUSION_IMAGE_FRAME **

		Arg_NuiFusionCreateImageFrame(int frameType, int width, int height,
				Struct_NUI_FUSION_CAMERA_PARAMETERS pCameraParameters, long[] ppImageFrame) {
			this.frameType = frameType;
			this.width = width;
			this.height = height;
			this.pCameraParameters = pCameraParameters;
			this.ppImageFrame = ppImageFrame;
		}
	}
	
	public int NuiFusionCreateImageFrame(int frameType, int width, int height,
			Struct_NUI_FUSION_CAMERA_PARAMETERS pCameraParameters, long[] ppImageFrame) throws Exception_KINECT {
		Arg_NuiFusionCreateImageFrame arg = new Arg_NuiFusionCreateImageFrame(
				frameType, width, height, pCameraParameters, ppImageFrame);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionCreateImageFrame], arg);
		
		System.out.println("NuiFusionCreateImageFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("NuiFusionCreateImageFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionCreateImageFrame");
		
		return intRtn;
	}
	
	/*
	HRESULT NuiFusionReleaseImageFrame(
	         NUI_FUSION_IMAGE_FRAME *pImageFrame
	)
	 */
	private class Arg_NuiFusionReleaseImageFrame extends Arg_property {
		private long pImageFrame; // NUI_FUSION_IMAGE_FRAME *

		Arg_NuiFusionReleaseImageFrame(long pImageFrame) {
			this.pImageFrame = pImageFrame;
		}
	}
	
	public int NuiFusionReleaseImageFrame(long pImageFrame) throws Exception_KINECT {
		Arg_NuiFusionReleaseImageFrame arg = new Arg_NuiFusionReleaseImageFrame(pImageFrame);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionReleaseImageFrame], arg);
		
		System.out.println("NuiFusionReleaseImageFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("NuiFusionReleaseImageFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionReleaseImageFrame");
		
		return intRtn;
	}

	/*
	HRESULT NuiFusionShadePointCloud(
		const NUI_FUSION_IMAGE_FRAME *pPointCloudFrame,
		const Matrix4 *pWorldToCameraTransform,
		const Matrix4 *pWorldToBGRTransform,
		const NUI_FUSION_IMAGE_FRAME *pShadedSurfaceFrame, 
		const NUI_FUSION_IMAGE_FRAME *pShadedSurfaceNormalsFrame
	)
	 */
	private class Arg_NuiFusionShadePointCloud extends Arg_property {
		private long pPointCloudFrame;  // const NUI_FUSION_IMAGE_FRAME *
		private @_Const Struct_Matrix4 pWorldToCameraTransform;
		private @_Const Struct_Matrix4 pWorldToBGRTransform;
		private long pShadedSurfaceFrame;  // const NUI_FUSION_IMAGE_FRAME *
		private long pShadedSurfaceNormalsFrame;  // const NUI_FUSION_IMAGE_FRAME *

		Arg_NuiFusionShadePointCloud(long pPointCloudFrame, Struct_Matrix4 pWorldToCameraTransform,
				Struct_Matrix4 pWorldToBGRTransform, long pShadedSurfaceFrame,
				long pShadedSurfaceNormalsFrame) {
			this.pPointCloudFrame = pPointCloudFrame;
			this.pWorldToCameraTransform = pWorldToCameraTransform;
			this.pWorldToBGRTransform = pWorldToBGRTransform;
			this.pShadedSurfaceFrame = pShadedSurfaceFrame;
			this.pShadedSurfaceNormalsFrame = pShadedSurfaceNormalsFrame;
		}
	}
	
	public int NuiFusionShadePointCloud(long pPointCloudFrame, Struct_Matrix4 pWorldToCameraTransform,
			Struct_Matrix4 pWorldToBGRTransform, long pShadedSurfaceFrame,
			long pShadedSurfaceNormalsFrame) throws Exception_KINECT {
		Arg_NuiFusionShadePointCloud arg = new Arg_NuiFusionShadePointCloud(pPointCloudFrame,
				pWorldToCameraTransform, pWorldToBGRTransform, pShadedSurfaceFrame, 
				pShadedSurfaceNormalsFrame);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionShadePointCloud], arg);
		
		System.out.println("NuiFusionShadePointCloud rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arg.getLastError()));
		
		if (H_JInvoker.JINVOKER_ERR_MAX < arg.getLastError() && arg.getLastError() < 0) throw new Exception_KINECT("NuiFusionShadePointCloud");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionShadePointCloud");
		
		return intRtn;
	}

	
	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	private class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	private class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	private class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}

}
